<template>
    <div class="bus-lines-wrapper block block--with-paddings block--no-oveflow" v-if="!isLoading">
        <h2 class="heading">Select Bus Line</h2>
        <ul class="bus-lines">
            <li class="bus-line" v-for="busLine in busLines" :key="busLine">
                <button @click="onBusLineClick(busLine)" type="button" :class="{
                    'btn btn-primary': true,
                    'active': busLine === selectedBusLine
                }">
                    {{ busLine }}
                </button>
            </li>
        </ul>
    </div>

    <div class="content-wrapper" ref="content">
        <Content class="content-block" :title="`Bus Line: ${selectedBusLine}`" sort-order="asc"
            placeholder="Please select the bus line first" subtitle="Bus stops" :data="busStopNames"
            @item-selected="onBusStopClick" :sortable="true" :selected="selectedBusStop" :render-callback="renderCallback"
            :sort-callback="sortCallback" :filter-callback="filterCallback" />
        <Content class="content-block" :title="`Bus Stop: ${selectedBusStop}`"
            placeholder="Please select the bus stop first" subtitle="Time" :data="timeSchedule" />
    </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from 'vue';
import { useStore } from "vuex";
import Content from '@/components/Content.vue';
import useBusStopUtils from '@/mixins/useBusStopUtils';
import { MappedBusStop } from '@/store';
import { BusStop } from '@/services/busStopService';

export default defineComponent({
    mixins: [useBusStopUtils],
    setup() {
        const store = useStore();
        const { busLines, busStopsByBusLine } = store.getters;
        const { transportInfo } = store.state;

        const selectedBusLine = ref<string | undefined>(undefined);
        const selectedBusStop = ref<string | undefined>(undefined);

        const busStopNames = computed(() => busStopsByBusLine(selectedBusLine.value) || []);
        const timeSchedule = computed(() => {
            if (selectedBusLine.value && selectedBusStop.value) {
                const data = transportInfo[selectedBusLine.value][selectedBusStop.value].time;
                return data.sort((t1: string, t2: string) => {
                    const [h1, m1] = t1.split(':').map(Number);
                    const [h2, m2] = t2.split(':').map(Number);

                    if (h1 < h2) {
                        return h1 - h2;
                    } else if (h1 === h2 && m1 < m2) {
                        return m1 - m2;
                    } else {
                        return 0;
                    }
                });
            }
            return [];
        });

        const onBusLineClick = (busLine: string) => {
            selectedBusLine.value = busLine;
            selectedBusStop.value = undefined;
        }

        const onBusStopClick = (busStop: MappedBusStop<BusStop>) => {
            selectedBusStop.value = busStop.stop;
        }

        return {
            busLines,
            onBusLineClick,
            busStopNames,
            timeSchedule,
            onBusStopClick,
            selectedBusLine,
            selectedBusStop,
            isLoading: ref(store.state.isLoading)
        }
    },
    components: {
        Content
    },
    methods: {
        // To make dynamic content width on resize
        // here we calculate available space and set it directly to content wrapper
        calculateContentBlockDynamicHeight() {
            const appContainer = window.document.querySelector('.app');
            const busLines = appContainer?.querySelector('.bus-lines-wrapper');
            const el = this.$refs.content as HTMLElement;

            if (el && appContainer && busLines) {
                const appBoundaries = appContainer.getBoundingClientRect();
                const busLinesBoundaries = busLines?.getBoundingClientRect();
                const { paddingTop: pT } = getComputedStyle(appContainer)
                const containerHeightWithoutPaddings = appBoundaries.height - parseFloat(pT);
                el.style.height = `${(containerHeightWithoutPaddings || 0) - (busLinesBoundaries?.bottom || 0)}px`;
            }
        },
    },
    mounted() {
        window.addEventListener('resize', () => {
            this.calculateContentBlockDynamicHeight();
        });
    },
    updated() {
        this.calculateContentBlockDynamicHeight();
    },
});
</script>

<style lang="scss" scoped>
.bus-lines {
    display: flex;
    flex-wrap: wrap;
    list-style: none;
    padding-left: 0;
    margin: 32px -8px -8px 0;
}

.bus-line {
    margin-bottom: 8px;
    margin-right: 8px;

    .btn {
        font-size: 12px;
        font-weight: 500;
    }
}

.content-wrapper {
    display: flex;
    justify-content: space-between;
    flex-grow: 2;
}

.content-block {
    width: calc(50% - 8px);
}
</style>